# Quick Start

Get a Programmable Agent running in three steps.

{% stepper %}
{% step %}

#### Create an Agent YAML

Commit this file at `.dinoai/agents/data-quality-checker.yml` in your repo:

```yaml
name: data-quality-checker
version: 1

role: >
  dbt™ Data Quality Specialist focused on test coverage and documentation
  completeness across analytics models.

goal: >
  Ensure all dbt™ models have appropriate tests and are fully documented
  before promotion to production.

backstory: >
  You have deep knowledge of dbt™ best practices and data quality patterns.
  You are methodical and prefer to verify before acting.

tools:
  mode: allowlist
  list:
    - read_file
    - search_files_and_directories
    - ripgrep_search
    - run_sql_query
    - list_all_snowflake_databases
    - list_all_columns_in_snowflake_table
    - post_slack_message

slack:
  channel: "#data-quality-alerts"
```

{% endstep %}

{% step %}

#### Trigger a Run

**cURL**

```bash
curl -X POST $PARADIME_API_ENDPOINT \
  -H "X-API-KEY: $PARADIME_API_KEY" \
  -H "X-API-SECRET: $PARADIME_API_SECRET" \
  -H "Content-Type: application/json" \
  -d '{
    "query": "mutation Trigger($agent: String, $message: String) { triggerDinoaiAgentRun(agent: $agent, message: $message) { ok agentSessionId status } }",
    "variables": {"agent": "data-quality-checker", "message": "Focus on stg_orders"}
  }'
```

**Python**

```python
import requests

url = f"$PARADIME_API_ENDPOINT"
headers = {
    "X-API-KEY": api_key,
    "X-API-SECRET": api_secret,
    "Content-Type": "application/json",
}

mutation = """
mutation Trigger($agent: String, $message: String) {
  triggerDinoaiAgentRun(agent: $agent, message: $message) {
    ok
    agentSessionId
    status
  }
}
"""

response = requests.post(url, headers=headers, json={
    "query": mutation,
    "variables": {"agent": "data-quality-checker", "message": "Focus on stg_orders"},
})
session_id = response.json()["data"]["triggerDinoaiAgentRun"]["agentSessionId"]
```

**Response:**

```json
{
  "data": {
    "triggerDinoaiAgentRun": {
      "ok": true,
      "agentSessionId": "run_abc123",
      "status": "queued"
    }
  }
}
```

{% endstep %}

{% step %}

#### Poll for Results

```bash
curl -X POST https://api.paradime.io/api/v1/{company_token}/graphql \
  -H "X-API-KEY: $PARADIME_API_KEY" \
  -H "X-API-SECRET: $PARADIME_API_SECRET" \
  -H "Content-Type: application/json" \
  -d '{
    "query": "query Run($id: String!) { dinoaiAgentRun(agentSessionId: $id) { ok status messages { ts role content } childSessionIds } }",
    "variables": {"id": "run_abc123"}
  }'
```

`status` will progress through: `QUEUED` → `RUNNING` → `COMPLETED` or `FAILED`
{% endstep %}
{% endstepper %}

***

### Next Steps

* [YAML Configuration](/app-help/products/dino-ai/programmable-agents/yaml-configuration.md) — Learn all available fields and options
* [API Reference](/app-help/products/dino-ai/programmable-agents/api-reference.md) — Full GraphQL mutation and query reference
* [Tools Reference](/app-help/products/dino-ai/programmable-agents/tools-reference.md) — See all tools available to your agents
* [Examples](/app-help/products/dino-ai/programmable-agents.md)  — See tutorials on how to get started deploying agents


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.paradime.io/app-help/products/dino-ai/programmable-agents/quick-start.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
